package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.MerchantVoiceDeviceService;
import com.gxwebsoft.shop.entity.MerchantVoiceDevice;
import com.gxwebsoft.shop.param.MerchantVoiceDeviceParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 商铺播报设备控制器
 *
 * @author 科技小王子
 * @since 2025-05-28 21:07:20
 */
@Api(tags = "商铺播报设备管理")
@RestController
@RequestMapping("/api/shop/merchant-voice-device")
public class MerchantVoiceDeviceController extends BaseController {
    @Resource
    private MerchantVoiceDeviceService merchantVoiceDeviceService;

    @ApiOperation("分页查询商铺播报设备")
    @GetMapping("/page")
    public ApiResult<PageResult<MerchantVoiceDevice>> page(MerchantVoiceDeviceParam param) {
        // 使用关联查询
        return success(merchantVoiceDeviceService.pageRel(param));
    }

    @ApiOperation("查询全部商铺播报设备")
    @GetMapping()
    public ApiResult<List<MerchantVoiceDevice>> list(MerchantVoiceDeviceParam param) {
        // 使用关联查询
        return success(merchantVoiceDeviceService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:merchantVoiceDevice:list')")
    @ApiOperation("根据id查询商铺播报设备")
    @GetMapping("/{id}")
    public ApiResult<MerchantVoiceDevice> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(merchantVoiceDeviceService.getByIdRel(id));
    }

    @ApiOperation("添加商铺播报设备")
    @PostMapping()
    public ApiResult<?> save(@RequestBody MerchantVoiceDevice merchantVoiceDevice) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
         merchantVoiceDevice.setUserId(loginUser.getUserId());
        }
        if (merchantVoiceDeviceService.save(merchantVoiceDevice)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改商铺播报设备")
    @PutMapping()
    public ApiResult<?> update(@RequestBody MerchantVoiceDevice merchantVoiceDevice) {
        if (merchantVoiceDeviceService.updateById(merchantVoiceDevice)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除商铺播报设备")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (merchantVoiceDeviceService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加商铺播报设备")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<MerchantVoiceDevice> list) {
        if (merchantVoiceDeviceService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改商铺播报设备")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<MerchantVoiceDevice> batchParam) {
        if (batchParam.update(merchantVoiceDeviceService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除商铺播报设备")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (merchantVoiceDeviceService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
